---
title: Release!
date: 21-07-2020
...

```{=html}
<video width=100% autoplay loop>
  <source src="https://alistairmichael.com/media/gamedemo_small.mp4" type="video/mp4">
</video> 
```


[high quality demo video](https://vimeo.com/440607394)

At long last I have a version of the game that I can show to people. 

I have made a distributable binary for linux, and windows, finally. That can be 
found [here](https://git.topost.net/alistair/space_game/releases). 

Now, does
this mean it has meaningful gameplay and is bug free? Of course not. But to look
back on the past year of working on this project here and there here is what I
have achieved:

- Drawing shapes to the screen using libsdl
- A update-draw game loop and datastructures for looking after objects that
    exist in the game world
- A 2D vector arithmetic library, for addition, scalar multiplication,
    projection, mod and arg, et cetera.
- A system for adding and removing forces to objects using timeouts.
- A basic 2D physics system with gravity where the player can be moved around
    using force impulses turned on and off by user input
- A viewport that can move to follow the player
- A simple world generated using a random walk 
- A collision detection system using the Separating Axis Theorem to detect and
    recover from collisions between the player and the world
- Wires that can attach the player to a point in the world and make it act like 
    a pendulum.
- A winch and ratchet that can shorten the rope using a specific amount of force 
    to hoist the player.
- Extending physics to simulate friction and partially elastic collisions.
- HSV-HSL-RGB colour space converters and a colour-pallette geerator
- An automatically growing and shrinking array list structure to improve object
    management

Part of what makes this project very enjoyable to work on is the fact I can pick
a very short term feature goal and work on that for a day, and usually have a
MVP to show for it within a few hours of work. The program is small enough to
fit in my head, so I could happily leave it for a couple days if I came across a
but I didn't feel motivated to bang my head against, and come back to it later.

C is, admittedly, not the best language for designing something iteratively, but
I absolutely designed this game very iteratively. I had no idea what I was doing
the whole time. There were several times, especially when developing the
collision detection and pendulum physics, that I exhausted myself and could not
think of any more bug hypotheses to test. At those times leaving it for a week,
or 10, was helpful. The fact that it is broken into such small pieces and
designed iteratively really helped me get back into it. 

That is partly why I love writing C, what I have done of it. Most of the
problems I had to solve here were micro-problems. Why am I reading an
out-of-bounds value from this array? Why is my physics _doing that_. Why is it
crashing? I can very easly get sucked into solving one small thing after
another, and seeing the bit of progress each time. It's like its own addicting
game.

There are still things I want to do with it. I mainly want to add a timer to the
levels so there is at least some gameplay. I also need menus: a simple save/quit
menu and a startup menu where you can input the level seed directly. The last
thing is sound effects and music, but that requires sourcing or making assets.
In the long term, I think a basic skill tree: upgrades (physics tweaks) that are
unlockable by completing a level in under a certain time, would be a good
addition.

Right now, I'm going to leave it for a while. I think I can learn new things
more productively by working on other projects. 

