---
title: Solving ODEs

1.  Consider the following homogeneous linear second order ODE with
    constant coefficients:

    $$ay'' + by' + cy = 0$$

    The characteristic equation is $a \lambda ^2 + b\lambda + c = 0$.

2.  If $a \lambda ^2 + b\lambda + c = 0$ has two real and distinct
    roots, $\lambda_1$ and $\lambda_2$, then
    $y(t) = c_1e^{\lambda_1 t} + 
            c_2e^{\lambda_2t}$.

    If $\lambda _1 , \lambda _2 < 0$, $y \to 0$ as $t\to \infty$.

    If $\lambda _1$ or $\lambda _2 > 0$, $y \to \pm \infty$ as
    $t\to \infty$, depending on the values of the coefficients.

3.  If $a \lambda ^2 + b\lambda + c = 0$ has one root, $\lambda$, then
    $y(t) = (c_1 + c_2t)e^{\lambda t}$.

    Reduction of order.

4.  If $a \lambda ^2 + b\lambda + c = 0$ has complex roots,
    $a \pm i\beta$, then
    $y(t) = e^{at}( A \cos\beta t + B\sin(\beta t))$.

5.  Now consider the following inhomogeneous linear second order ODE
    with constant coefficients:

    $$ay'' + by' + cy = r(x)$$

    The general solution is $y = y_H + y_p$, where $y_H$ is the solution
    to the homogeneous ODE $ay'' + by' + cy' = 0$, and $y_p$ is a
    particular solution to the inhomogeneous ODE. $y_p$ may be found
    using the method of underdetermined coefficients.

      Examples of $r(x)$     |        Choice for $y_p$          
      -----------------------|--------------------------------- 
      $2x + 3$               |            $ax + b$              
      $e^{2x}$               |            $Ae^{2x}$             
      $\sin(x)$              |      $A\sin(x) + B\cos(x)$       
      $\cos(x)$              |      $A\sin(x) + B\cos(x)$       
      $2\sin(x) + 3\cos(x)$  |      $A\sin(x) + B\cos(x)$       
      $xe^x$                 |          $(ax + b)e^x$           
      $e^x \sin (2x)$        |  $e^x (A\sin(2x) + B\cos(2x))$   
      $e^{2x} + \sin (x)$    | $Ae^{2x} + B\sin(x) + C\cos(x)$  

6.  Simple Harmonic Motion & Damped Oscillations ($m$ is the mass of the
    weight attached to the spring, $k$ is the spring constant, and
    $\beta$ is the dampinc constant)

    Simple Harmonic Motion (Undamped): $mx'' + kx = 0$

    Damped Oscillation: $mx'' + \beta x' + kx = 0$
