---
title: Email Isn't Actually Impossible
date: 12-12-2019
...

A couple of months ago, Gilles, who writes the blog at poolp.org and works on the OpenBSD mail server OpenSMTPD wrote a post claiming that "Email is Hard" is an inadequate reason for not- self-hosting an email server. If you are reasonably technical, have patience and have minimal consequences for potential email downtime, then the only thing stopping you running your own email server is the doing the work to set it up. After following the [excellent guide](https://poolp.org/posts/2019-09-14/setting-up-a-mail-server-with-opensmtpd-dovecot-and-rspamd/) he wrote to setting up OpenSMTPD I'm inclined to agree. 

This is partly because of the OpenBSD project, who are resposible for OpenSMTPD, and their focus on simplicity and correctness in the implementation. They provide a very straightforward setup process for the basic use case. After playing with the config files for a couple of days they really make sense and seem quite elegant and terse.

Having searched "how to set up an email server" I found a massive ars-technica series on doing it with Postfix, the "standard" SMTP server implementation and it does not look fun, I can say. However it is likely more powerful than OpenSMTPD. There are also several blog posts warning of the inevitable blacklisting and undeliverability issues with hosting your own main which I'm so glad to see didn't appear when I set up my server.

Straight away, with a 1 day old domain name and after spending maybe 4 hours following Gilles guide to set up DNS records, SPF, DKIM, an DMARC, I had an email server with spam filtering, and that I could connect to from my phone and send emails to the inbox of GMail and Zoho (my usual free mail provider). Unfortunately Office365 mail does deliver me to the spam folder. Hopefully that will improve once the address has existed for a while and gained reputation, but it may just be something I have to accept. 

The hardest part of the setup process was compiling OpenSMTPD and the filter plugins from source on Ubuntu[^1], because the repository version was too old to support the nice spam-filter syntax in the config file. Thankfully the documentation provided with the source was good, and I was able to install all the dependencies without too much trouble. 

At any rate this was more of an experiment, so I am happy. I have not set up a backup server to take over in case of downtime and I'm not sure I will, since it is only for me. So doing that was a fun couple of days, and I agree with the claim that it would be "better" in an abstract sense, if more people used smaller mail providers to so that one of the few truly decentralised methods of communcation stays that way. It is a service that has always been "unmediated" by technology, the protocol is just the messenger and not the "platform". The mail transfer protocol does not carry all the responsibilities that _platforms_ like GMail, Outlook and Yahoo do have and maybe that is why it has been safe for the past 30 years.

Of course, it is forever moving the other way: Gmail and company own so much of the market that if they decide your email-reputation is not up to scratch they can singlehandedly make your service worthless, [as with their other platforms](https://www.youtube.com/watch?v=DIssymQvrbU).

All hope is not lost though, just this week Jack Dorsey, Twitter CEO, announced plans to invest a team in developing an open Social Network standard that would be interoperable with twitter. Despite however cynical you can be about this, it is at least interest in the idea of platform-agnostic communication. Perhaps more substantially, the ActivityPub protocol, the open Social Network communication standard used by Plemora, Mastodon, Peertube, Plume, Pixel fed et cetera, reached W3C Recommended status in November last year. This essentially makes it a "Web Standard" like HTML5, and SSL. Personally, I am quite excited about ActivityPub, and I hope it helps open protocols triumph over commercial services more broadly.  

[^1]: A choice I made because I want to be able to run obscure self-hosted web applications like [shiori](https://github.com/go-shiori/shiori) that I don't have the know-how to port to BSD.
