---
title: The World's Ugliest Static Site Generator
date: 3-10-2019
...

Here we are again. 

I rewrote my blog generator, because I decided not to try to deal with the ugly python I wrote last year instead opting to try and keep it as _minimalist_ and as possible: no more than a makefile, a 200MB markdown parser... and in the end a hundred lines of python to help tie it together. I think the purpose of this project was to learn more of the standard gnu utilities for text manipulation, but I ended up copying and pasting so much Makefile syntax off stack I think that purpose was lost in the midst, which was when I gave up and started using python again.

It still does less than the old one, which is quite something. It _does_ support pandoc[^2] markdown by calling pandoc directly, which is some improvement over python's markdown[^1] that I was trying to wrangle before. 

### Pandoc

Pandoc is the markdown parser that I use for all of my Uni notes and just about any writing that doesn't require LaTeX. It is phenomenal, not only being able to convert between a [dizzying array](https://pandoc.org/diagram.jpg) of document formats, but offering one of the most featureful and well-defined markdown dialects available.  

Markdown itself is the very simple plaintext markup language that is partially supported by just about every messaging app, and notably social networks like Reddit, for at least basic things like bold, italic and lists. However it is capable of a lot more than that, and there exist many many, different iterations on basic markdown syntax that allow for more complex formatting like tables, code blocks, embedded maths, audio, vidoes and everything possible on the web.

Since markdown was designed for web publishing, Pandoc is notable because it provides extra functionality specific to paper document generation. It can convert markdown to PDF via LaTeX to produce really beautiful looking documents. 

Anyway, all that really means is I can have nice-looking code blocks and footnotes. 

## Functionality 

Regardless, my site generator works much the same as before.

1. Listing everything in the `/posts` directory, passing it to a python script to make a markdown formatted list of posts that is sorted by date, adding a header and footer and sending it to pandoc to build `index.html`. 
2. Listing everything in `/posts` and `/pages` and sending it to pandoc to convert to html and plonk them in an 'out' directory. 

[^1]: Yes, I could have achieved this by calling pandoc from python, but I don't know. No. 
[^2]: [pandoc.org](https://pandoc.org)

## Missing Functionality

- RSS feed generation, but even I only really _pretend_ to use that, I don't know of anyone outside of 90s UNIX programmers on hackernews who still do[^3].
- Post tagging or categorisation
- Fine control of included content on each page
- Search

[^3]: Don't @ me!

To address these in reverse order:

### Search

- Hey man, I won't be writing that much.

### Fine Control of Included Content

Other static site generators allow complex substitutions of text and html elements in individual pages through linking to different files and templating. I would like to support some kind of templating, and the ability to substitute a piece of text for a given variable at any point. That would require me to make the Makefile more generalised however...

### Post Tagging and Categorisation

Ah the tree, truly a transcendent representation of related data. One day, my makefile should be able to recursively traverse a filetree and generate the content for all the markdown documents it contains allowing categorisation of content by the folders it is placed in.

### RSS

I'm not very hyped about RSS right now [^4]. It has low usage outside of podcast publishing and I'm not sure it's worth it. More importantly, I am also not sure how to do it outside of using a python module and giving the python script all the posts.

[^4]: Yes, that does imply I've been hyped about RSS in the past. [Link](https://twobithistory.org/2018/12/18/rss.html) for you if you don't know what RSS is (and are prepared to read for half an hour).

That is about all I can say really. I was supposed to do Uni work today but instead was more productive than I have ever been this week working on my poor little webserver. 

Oh well.



